package cl.axg.hls_player;


import android.app.Activity;
import android.content.Intent;
import android.content.res.Configuration;
import android.graphics.Color;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.TextView;


import androidx.annotation.RequiresApi;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.StringRequest;
import com.android.volley.toolbox.Volley;
import com.google.android.exoplayer2.DefaultRenderersFactory;
import com.google.android.exoplayer2.ExoPlaybackException;
import com.google.android.exoplayer2.Player;
import com.google.android.exoplayer2.SimpleExoPlayer;
import com.google.android.exoplayer2.source.MediaSource;
import com.google.android.exoplayer2.source.ProgressiveMediaSource;
import com.google.android.exoplayer2.source.dash.DashMediaSource;
import com.google.android.exoplayer2.source.hls.HlsMediaSource;
import com.google.android.exoplayer2.trackselection.DefaultTrackSelector;
import com.google.android.exoplayer2.ui.PlayerView;
import com.google.android.exoplayer2.upstream.DefaultHttpDataSource;
import com.google.android.exoplayer2.upstream.DefaultHttpDataSourceFactory;
import com.google.android.exoplayer2.util.Util;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;


import java.text.ParseException;
import java.util.ArrayList;

public class ZappingActivity extends Activity {

    private static final String TAG = "ZappingActivity";

    private  PlayerView playerView;
    private  SimpleExoPlayer player;
    private  Handler mHandler = new Handler();
    private  Runnable mRunnable;
    private  boolean hayError;
    static  int playVideoAtIndex=0;
    private ImageView btnCloseVideo = null;
    private ImageView btnPreviousVideo = null;
    private ImageView btnNextVideo = null;
    private ImageView btnInfoEPGVideo = null;
    private ImageView btnNextVideoStreaming = null;
    private ImageView btnPreviousVideoStreaming = null;
    private ProgressBar seekBar = null;
    static ArrayList<Video> canales;
    private ArrayList<EPG> epgList ;
    private String urlEPG = null;
    private EPG currentEPG = null;
    private  Common common = new Common();
    private  boolean isSearchingItem;



    public void closeImgBtnOnClick(View v)
    {
        this.finish();
    }
    @Override
    public void onWindowFocusChanged(boolean hasFocus) {
        super.onWindowFocusChanged(hasFocus);
        if (hasFocus) {
            common.habilitarPreferenciasReproductor(getWindow());
        }
    }
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        common.habilitarVentanaEncendida(getWindow());
        canales = new ArrayList<Video>();

        Intent intent = getIntent();

        String jsonCanales = intent.getStringExtra("canales");
        isSearchingItem  =   intent.getExtras().getBoolean("isSearchingItem");
        playVideoAtIndex = intent.getIntExtra("playVideoAtIndex",0);
        urlEPG = intent.getStringExtra("urlEPG");

        try {
            JSONArray jsonArray = new JSONArray(jsonCanales);

            for (int i=0; i < jsonArray.length(); i++) {
                JSONObject jsonObject = jsonArray.optJSONObject(i);
                int  vivo       =  Integer.parseInt(jsonObject.getString("vivo"));
                String titulo       = jsonObject.getString("titulo");
                String descripcion       = jsonObject.getString("descripcion");
                String   imagenPath  = jsonObject.getString("imagenPath");
                int   numeroCanal  = Integer.parseInt(jsonObject.getString("numeroCanal"));
                int   studio  = Integer.parseInt(jsonObject.getString("studio"));
                String linkReproductor  = jsonObject.getString("linkReproductor");

                final Video video = new Video(vivo, titulo, descripcion, imagenPath,    numeroCanal,   studio,      linkReproductor );

                canales.add(video);
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }


        setContentView(R.layout.activity_zapping);
        common.ignoreSSL();
        setUp();

    }

    public void closeinfoEPGVideoClick(View arg0)
    {
        View layout_epg = (View)findViewById(R.id.epg);
        layout_epg.setVisibility(View.INVISIBLE);
        View txtDescripcion = (View)findViewById(R.id.txtDescripcion);
        txtDescripcion.setVisibility(View.INVISIBLE);

        View epg_descripcion = (View)findViewById(R.id.epg_bottom);
        epg_descripcion.setVisibility(View.INVISIBLE);


        btnCloseVideo.setVisibility(View.VISIBLE);
        btnInfoEPGVideo.setVisibility(View.VISIBLE);
        HideControlPreviousNextWhenIsSearchingItem();
    }
    public void nextVideoClick(View arg0) {
        final int longitudArreglo = canales.size()-1;


        if(playVideoAtIndex == longitudArreglo){
            playVideoAtIndex=0;
            initControls();
            initEPG();
            actualizarEPG();
            prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
            player.setPlayWhenReady(true);
            hayError = false;
        }else{

            playVideoAtIndex+=1;

            initControls();

            initEPG();
            actualizarEPG();
            prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
            player.setPlayWhenReady(true);
            hayError = false;
        }


    }

    public void previousVideoClick(View arg0)
    {
        if(playVideoAtIndex > 0){
            playVideoAtIndex-=1;

            initControls();
            initEPG();

            actualizarEPG();
            prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
            player.setPlayWhenReady(true);
            hayError = false;

        }else{
            playVideoAtIndex =canales.size()-1;

            initControls();
            initEPG();

            actualizarEPG();
            prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
            player.setPlayWhenReady(true);
            hayError = false;
        }


    }
    private void setUp() {

        initializePlayer();
        initControls();
        initEPG();
    }

    private void initializePlayer() {
        playerView = this.findViewById(R.id.playerViewZapping);
        player = common.initPlayer(this, playerView);
        ImageView playPauseVideo =  findViewById(R.id.playPauseVideo);
        playPauseVideo.setImageResource(  R.drawable.exo_icon_pause);
        playerView.getVideoSurfaceView().setOnClickListener(view -> {
            if (playerView.isControllerVisible()) {
                // Do something if controls are visible
                playerView.hideController();


                Log.e("TOUCH", "hideController!");



            } else {
                // Do something else if controls are not showing
                playerView.showController();

                View someView = findViewById(R.id.viewControl);
                someView.setBackgroundResource( R.drawable.exoplayer_bottom);

                Log.e("TOUCH", "showController!");
            }
        });
        playerView.getVideoSurfaceView().setOnClickListener(view -> {

            if (playerView.isControllerVisible()) {
                // Do something if controls are visible
                playerView.hideController();


                Log.e("TOUCH", "hideController!");

                if(!isVivo()){
                    View layout_epg = (View)findViewById(R.id.epg);
                    layout_epg.setVisibility(View.VISIBLE);
                    View epg_descripcion = (View)findViewById(R.id.epg_bottom);
                    epg_descripcion.setVisibility(View.VISIBLE);

                }
                View viewControl = (View)findViewById(R.id.viewControl);
                viewControl.setBackgroundColor(Color.TRANSPARENT);


            } else {
                // Do something else if controls are not showing
                playerView.showController();

                View someView = findViewById(R.id.viewControl);
                someView.setBackgroundResource( R.drawable.exoplayer_bottom);

                btnCloseVideo.setVisibility(View.VISIBLE);


                if(!isVivo()){
                    TextView txtDescripcion =  findViewById(R.id.txtDescripcion);
                    txtDescripcion.setVisibility(View.VISIBLE);


                    Video video   = canales.get(playVideoAtIndex);
                    txtDescripcion.setText(video.getDescripcion());

                    View epg_descripcion = (View)findViewById(R.id.epg_bottom);
                    epg_descripcion.setVisibility(View.INVISIBLE);
                    View layout_epg = (View)findViewById(R.id.epg);
                    layout_epg.setVisibility(View.INVISIBLE);
                    btnInfoEPGVideo.setVisibility(View.VISIBLE);
                }else{

                    View epg_descripcion = (View)findViewById(R.id.epg_bottom);
                    epg_descripcion.setVisibility(View.VISIBLE);
                }
                Log.e("TOUCH", "showController!");
            }
        });
        playerView.requestFocus();
        if(mHandler!=null)
            mHandler.removeMessages(0);
        DefaultTrackSelector trackSelector = new DefaultTrackSelector(this);
        trackSelector.setParameters(trackSelector.buildUponParameters()
                .setMaxAudioChannelCount(1)
        );
        //inicio definicio - habilitar codec AC3 FFMPEG
        DefaultRenderersFactory factory = new DefaultRenderersFactory(this);
        factory.setExtensionRendererMode(DefaultRenderersFactory.EXTENSION_RENDERER_MODE_PREFER);
        //fin definicio - habilitar codec AC3 FFMPEG

        player = new SimpleExoPlayer.Builder(this, factory).setTrackSelector(trackSelector).build();

        playerView.setPlayer(player);
        playerView.setShowBuffering(PlayerView.SHOW_BUFFERING_ALWAYS);
        player.addListener(new Player.EventListener() {
            @Override
            public void onPlayerError(ExoPlaybackException error) {

                switch (error.type) {
                    case ExoPlaybackException.TYPE_SOURCE:
                        Log.e(TAG, "TYPE_SOURCE: " + error.getSourceException().getMessage());
                        stop();
                        break;

                    case ExoPlaybackException.TYPE_RENDERER:
                        Log.e(TAG, "TYPE_RENDERER: " + error.getRendererException().getMessage());
                        stop();
                        break;

                    case ExoPlaybackException.TYPE_UNEXPECTED:
                        Log.e(TAG, "TYPE_UNEXPECTED: " + error.getUnexpectedException().getMessage());
                        stop();
                        break;

                    default:
                        mHandler.postDelayed(new Runnable() {
                            @Override
                            public void run() {
                                hayError = true;
                                pause();
                                reproducir();
                            }
                        }, 1000 * 10);
                        break;
                }

            }

            @Override
            public void onPlayerStateChanged(boolean playWhenReady, int playbackState) {
                if(playbackState==Player.STATE_ENDED){
                    reproducir();
                }
            }
        });

        player.setPlayWhenReady(true);
        play(player);
    }

    public void pause(){
        player.setPlayWhenReady(false);
        hayError = false;
    }

    public void stop(){
        player.setPlayWhenReady(false);
        player.stop();
        player.seekTo(0);
    }

    public void play(SimpleExoPlayer player){
        Log.d("requestdebug_playVideo",Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()).toString());
        prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
        player.setPlayWhenReady(true);
        hayError = false;
    }

    public void reproducir(){

        prepareMediaForPlaying(Uri.parse(canales.get(playVideoAtIndex).getLinkReproductor()));
        player.setPlayWhenReady(true);
        hayError = false;
    }
    private void prepareMediaForPlaying(Uri mediaSourceUri) {

        DefaultHttpDataSourceFactory dataSourceFactory = new DefaultHttpDataSourceFactory(
                Util.getUserAgent(this, "VideoPlayerGlue"),
                DefaultHttpDataSource.DEFAULT_CONNECT_TIMEOUT_MILLIS,
                DefaultHttpDataSource.DEFAULT_READ_TIMEOUT_MILLIS,
                true);
        MediaSource    mediaSource = getMediaSource(mediaSourceUri , dataSourceFactory);
        player.prepare(mediaSource);
        player.setPlayWhenReady(true);

    }
    private MediaSource getMediaSource(Uri uri,DefaultHttpDataSourceFactory dataSourceFactory){
        String path = uri.getPath();

        String[] extension = path.split("\\.");
        int largo = extension.length;
        if(largo>1){
            switch (extension[largo-1].toUpperCase()){
                case "MPD":
                    return new DashMediaSource
                            .Factory(dataSourceFactory)
                            .createMediaSource(uri);
                case "M3U8":
                    return new HlsMediaSource
                            .Factory(dataSourceFactory)
                            .createMediaSource(uri);


            }
        }
        return new ProgressiveMediaSource.Factory(dataSourceFactory).
                createMediaSource(uri);
    }


    private void releasePlayer() {
        if (player != null) {
            player.release();
            player = null;
        }
    }
    private void pausePlayer() {
        if (player != null) {
            player.setPlayWhenReady(false);
            player.getPlaybackState();
        }
    }
    private void resumePlayer() {
        if (player != null) {
            player.setPlayWhenReady(true);
            player.getPlaybackState();
        }
    }


    public String getURL(){
        return canales.get(playVideoAtIndex).getLinkReproductor();
    }


    public void btnInfoEPGVideoClick(View arg0)
    {
        actualizarEPG();
        View layout_epg = (View)findViewById(R.id.epg);
        layout_epg.setVisibility(View.VISIBLE);
        View txtDescripcion = (View)findViewById(R.id.txtDescripcion);
        txtDescripcion.setVisibility(View.VISIBLE);
        View epg_descripcion = (View)findViewById(R.id.epg_bottom);
        epg_descripcion.setVisibility(View.VISIBLE);

        btnInfoEPGVideo.setVisibility(View.INVISIBLE);
        btnCloseVideo.setVisibility(View.INVISIBLE);
    }


    public void rewindVideoClick(View arg0)
    {
        player.seekTo(player.getCurrentPosition() - 10000);
    }

    public void playPauseVideoClick(View arg0)
    {
        ImageView playPauseVideo =  findViewById(R.id.playPauseVideo);
        playPauseVideo.setImageResource(player.isPlaying() ? R.drawable.exo_icon_play: R.drawable.exo_icon_pause);

        player.setPlayWhenReady(!player.isPlaying());
    }

    public void forwardVideoClick(View arg0)
    {
        player.seekTo(player.getCurrentPosition() + 10000);
    }

    private void actualizarEPG(){

        Video currentVideo  = canales.get(playVideoAtIndex);
        RequestQueue queue = Volley.newRequestQueue(this);
        String url = urlEPG.replace("STUDIO", String.valueOf(currentVideo.getStudio()));
        Log.d(TAG,"url consulta STUDIO: "+url);

        // Request a string response from the provided URL.
        StringRequest stringRequest = new StringRequest(Request.Method.GET, url,
                new Response.Listener<String>() {
                    @RequiresApi(api = Build.VERSION_CODES.N)
                    @Override
                    public void onResponse(String response) {
                        JSONObject jsonObject = null;
                        epgList = new ArrayList<EPG>();
                        TextView txtTitulo =  findViewById(R.id.txtCurrentPrograma);
                        TextView txtProximoTitulo =  findViewById(R.id.txtProximoTitulo);
                        TextView txtHoraInicio =  findViewById(R.id.txtHoraInicio);
                        TextView txtHoraFin =  findViewById(R.id.txtHoraFin);
                        seekBar =  findViewById(R.id.seekbar);
                        seekBar.setProgress(0);
                        try {
                            jsonObject = new JSONObject(response);

                            if (jsonObject.has("error")) {
                                Log.e(TAG, "token expirado");
                                return;
                            }

                            if (!jsonObject.has("epg")) {

                                txtTitulo.setText("Programa de "+currentVideo.getTitulo());
                                txtProximoTitulo.setText("Programa de "+currentVideo.getTitulo());
                                txtHoraInicio.setText("00:00");
                                txtHoraFin.setText("00:00");
                                Log.e(TAG, "no se ha encontrado propiedad EPG en JSON");
                                mHandler.removeCallbacks(mUpdateTimeTask);
                                return;
                                //throw new NullPointerException("no se ha encontrado propiedad EPG en JSON ");
                            }else{

                                JSONArray jsonArray = jsonObject.getJSONArray("epg");
                                for (int i=0; i < jsonArray.length(); i++) {
                                    JSONObject item = jsonArray.optJSONObject(i);

                                    EPG epg = new EPG(item.getString("titulo"),item.getString("fecha_ini"),item.getString("fecha_fin"),item.getString("run"),item.getString("anterior"),item.getString("siguiente"));
                                    epgList.add(epg);
                                }
                                if(epgList.size() == jsonArray.length()){


                                    long now = System.currentTimeMillis();
                                    for ( EPG item:epgList )
                                    {
                                        String hora_inicio_1000 = new java.text.SimpleDateFormat("HH:mm:ss").format(new java.util.Date(item.getHoraInicio()  * 1000));
                                        String hora_fin_1000 = new java.text.SimpleDateFormat("HH:mm:ss").format(new java.util.Date(item.getHoraFin()  * 1000));

                                        String hora_actual = new java.text.SimpleDateFormat("kk:mm:ss").format(new java.util.Date());


                                        if(new java.util.Date(item.getHoraInicio()  * 1000).before(new java.util.Date()) &&  new java.util.Date().after(new java.util.Date(item.getHoraFin()  * 1000))){

                                        }else{

                                            System.out.println("PROGRAMA MENOR ACTUAL HORA2: "+item.getTitulo());
                                            currentEPG = item;
                                            break;
                                        }
                                    }

                                    if(currentEPG != null){
                                        updateProgressBar();
                                        txtTitulo.setText(currentEPG.getTitulo());
                                        txtProximoTitulo.setText(currentEPG.getSiguiente());
                                        txtHoraInicio.setText(currentEPG.getHoraInicioFormato());
                                        txtHoraFin.setText(currentEPG.getHoraFinFormato());

                                    }else{
                                        Log.e(TAG, "Current EPG is null: "+url);
                                    }
                                }
                            }

                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                    }
                }, new Response.ErrorListener() {
            @Override
            public void onErrorResponse(VolleyError error) {
                Log.d(TAG, "That didn't work!"+error.toString());
            }
        });

        // Add the request to the RequestQueue.
        queue.add(stringRequest);
    }
    /**
     * Update timer on seekbar
     * */
    public void updateProgressBar() {
        mHandler.postDelayed(mUpdateTimeTask, 100);
    }

    /**
     * Background Runnable thread
     * */
    private Runnable mUpdateTimeTask = new Runnable() {
        public void run() {

            int valor = 0;
            try {
                valor = currentEPG.getPercentageLeft();
            } catch (Exception e) {
                e.printStackTrace();
            }
            seekBar.setProgress( valor );
            Log.d("PROGRESO","progreso es: "+valor);

            // Running this thread after 100 milliseconds
            mHandler.postDelayed(this, 100);
        }
    };



    /**
     * When user starts moving the progress handler
     * */

    private void  initEPG(){
        Video video   = canales.get(playVideoAtIndex);

        new DownloadImageTask(findViewById(R.id.imgCanal))
                .execute(video.getImagenPath());

        TextView txtNumeroCanal =  findViewById(R.id.txtNumeroCanal);
        TextView txtTituloCanal =  findViewById(R.id.txtTituloCanal);
        TextView txtDescripcion =  findViewById(R.id.txtDescripcion);

        Log.d(TAG, "current video: "+video.getTitulo());
        Log.d(TAG, "current video: "+video.getNumeroCanal());
        Log.d(TAG, "current video: "+video.getDescripcion());
        txtNumeroCanal.setText(video.getNumeroCanal());
        txtTituloCanal.setText(video.getTitulo());
        txtDescripcion.setText(video.getDescripcion());
    }
    private Boolean isVivo(){
        return canales.get(playVideoAtIndex).getIsVivo();
    }
    private void HideControlPreviousNextWhenIsSearchingItem(){

        if(isSearchingItem){
            btnPreviousVideo.setVisibility(View.INVISIBLE);
            btnNextVideo.setVisibility(View.INVISIBLE);
            btnPreviousVideoStreaming.setVisibility(View.INVISIBLE);
            btnNextVideoStreaming.setVisibility(View.INVISIBLE);
        }
    }
    private void initControls(){
        LinearLayout linearLayoutVOD =  findViewById(R.id.linearLayoutVOD);
        LinearLayout linearLayoutStreaming =  findViewById(R.id.linearLayoutStreaming);
        LinearLayout linearLayoutEPG =  findViewById(R.id.epg);
        btnCloseVideo = findViewById(R.id.btnCloseVideo);
        btnPreviousVideo = findViewById(R.id.btnPreviousVideoVOD);
        btnNextVideo = findViewById(R.id.btnNextVideoVOD);
        btnPreviousVideoStreaming = findViewById(R.id.btnPreviousVideoStreaming);
        btnNextVideoStreaming = findViewById(R.id.btnNextVideoStreaming);

        if (isVivo()){

            ImageView playPauseVideo =  findViewById(R.id.playPauseVideo);
            playPauseVideo.setImageResource( R.drawable.exo_icon_pause);//isPlaying ? R.drawable.exo_icon_pause:
            linearLayoutVOD.setVisibility(View.VISIBLE);
            linearLayoutStreaming.setVisibility(View.INVISIBLE);
            linearLayoutEPG.setVisibility(View.INVISIBLE);
        }else{

            linearLayoutVOD.setVisibility(View.INVISIBLE);
            linearLayoutStreaming.setVisibility(View.VISIBLE);
            linearLayoutEPG.setVisibility(View.INVISIBLE);
            View epg_descripcion = (View)findViewById(R.id.epg_bottom);
            epg_descripcion.setVisibility(View.INVISIBLE);
            View viewControl = (View)findViewById(R.id.viewControl);
            viewControl.setBackgroundColor(Color.TRANSPARENT);

            btnInfoEPGVideo = findViewById(R.id.btnInfoEPGVideo);
        }
        HideControlPreviousNextWhenIsSearchingItem();

    }
    @Override
    protected void onPause() {
        super.onPause();
        pausePlayer();
        if (mRunnable != null) {
            mHandler.removeCallbacks(mRunnable);
        }
    }
    @Override
    protected void onRestart() {
        super.onRestart();
        resumePlayer();
    }
    @Override
    protected void onDestroy() {
        super.onDestroy();
        releasePlayer();
    }


    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        // ignore orientation/keyboard change
        super.onConfigurationChanged(newConfig);
    }

    @Override
    public void onBackPressed() {
        Log.d("CDA", "onBackPressed Called");
        super.onBackPressed();
    }

}